/************************/ 
/*      chk1_er.c      */
/*      1996/12/9       */
/*      By Kanaoka      */
/************************/


#include "parse.h"

/***********	JISAGE-ERROR	**********/    

void Er_jisage(STMTREE1 *a)
{
	STMTREE1        *s1;
        STMTREE2        *s2;

	s1 = a;

	if(s1->stmtkind == CONDIT_STK || s1->stmtkind == ITERAT_STK){
		s2 = s1->to_stmt2;
		if(s2->code == IF_STC){	
			s1= s2->nextstmt1;
			if(s1->stmtkind == NULL_STK)
				printf("Warning:Line(%d) : You use ';' just after if(). Null_statement OK?\n",s1->line);
      			 }
		if(s2->code == FOR_STC){
			s1= s2->nextstmt1;
			if(s1->stmtkind == NULL_STK)
				printf("Warning:Line(%d) : You use ';' just after for(). Null_statement OK?\n",s1->line);
		 }
		 if(s2->code == WHILE_STC){
			 s1= s2->nextstmt1;
			 if(s1->stmtkind == NULL_STK)
				printf("Warning:Line(%d) : You use ';' just after while().NUll_statement OK?\n",s1->line);
	 	}
	}
}

/**********	CASE NOTHING  BREAK-ERROR     **********/	

void Er_casebreak(STMTREE1 *a)
{
        STMTREE1        *s1;
	STMTREE2        *s2;

 	s1 = a;

        if(s1->stmtkind == SELECT_STK){
		Flsw = 1;
		Flcs = 0;
		Flbk = 0;
		Fldf = 0;  
	}
	
	if(s1->stmtkind == SELECT1_STK ){
		s2=s1->to_stmt2;
		if( s2->code == CASE_STC){
			if(Flcs == 1 && Flbk == 0)
				printf("Warning:Line(%d) :breakERROR\n",s1->line-1);
			
			
			if(Fldf == 1){
				printf("Warning:Line(%d) :defaut-case\n",s1->line-1);
				Fldf = 0;
			}
			Flcs = 1;
			Flbk = 0;
		}
                if( s2->code == DEFAULT_STC){
			if(Flcs == 1 && Flbk == 0)
				printf("Warning:Line(%d) :breakERROR\n",s1->line-1);
			Fldf = 1;
		}
	}

									  if(s1->stmtkind == JUMP_STK ){
		  s2=s1->to_stmt2;
	 	  if( s2->code == BREAK_STC)
			   Flbk = 1;
	   }


}


/***********  BLANK-ERROR **********/

void Er_blank(STMTREE1 *a)
{


        STMTREE1        *s1, *s1b;
	STMTREE2        *s2;
	int k,k2;

	s1 = a;
	s1b = a;

	k = s1->column;

	printf("k:%dLine(%d)\n",k,s1->line); 
	while(s1->next != NULL){
		k = s1->column;
		s1= s1->next;
		printf("s1->next%d\n",s1->next);
		if(s1->column != k)
			printf("Warning:Line(%d) : BLANK:%d\n",k,s1->line);
		s2=s1->to_stmt2;
		if(s2->nextstmt1 != NULL)
			Er_blank(s2->nextstmt1);
	}
        s2 = s1->to_stmt2;
	while(s2->nextstmt1 != NULL){
		k2 = s2->column;
		s1 = s2->nextstmt1;
		printf("s1->next%d\n",s1->next);
		if(s1->column == k2)
			printf("Warning:Line(%d) : BLANK:%d\n",k2,s1->line);		s2 = s1->to_stmt2;
	}
	if(s1->next != NULL)
		 Er_blank(s1->next);


}
/*
void Er_blank1(STMTREE1 *a)
{
        STMTREE1        *s1;
        STMTREE2        *s2;
        int k,;

	s1 = a;

        printf("k:%dLine(%d)\n",k,s1->line);
        	
	while(s1->next != NULL){
                k = s1->column;
                s1= s1->next;
                if(s1->column != k)
                        printf("Warning:Line(%d) : BLANK:%d\n",k,s1->line);
                s2=s1->to_stmt2;
                if(s2->nextstmt1 != NULL)
                        Er_blank2(s2->nextstmt1);
        }
}
*/




