/*
	error3.c ver1.42
	1996/12/9
	by Kaneko
*/
#include "parse.h"

void	expr_chky();
int	expr_eq();
int	expr_and();
int	expr_or();

void	er_eq(STMTREE1 *a)
{
	STMTREE1	*s1;
	STMTREE2	*s2;
	EXPR		*e;

	s1 = a;

	if(s1->stmtkind == CONDIT_STK || s1->stmtkind == ITERAT_STK){
		s2 = s1->to_stmt2;
		if(s2->code == IF_STC || s2->code == IF_ELSE_STC){
			e = s2->arg1;
			expr_chky(e);
		}
		if(s2->code == WHILE_STC || s2->code == DO_WHILE_STC){
			e = s2->arg1;
			do{
				if(expr_eq(e) == 1)
					printf("Warning:File(%s):Line(%d):'While'ξＰ('=')ȤäƤޤ.\n",e->filename,e->line);
				if(expr_and(e) == 1)
					printf("Warning:File(%s):Line(%d):'While'ξＰǥӥåѼ('&')ȤäƤޤ.\n",e->filename,e->line);
				if(expr_or(e) == 1)
					printf("Warning:File(%s):Line(%d):'While'ξＰǥӥå¼('|')ȤäƤޤ.\n",e->filename,e->line);
			}while(e->next != NULL);
		}
	}
}

void	expr_chky(EXPR *a)
{
	EXPR	*e;

	e = a;

	if(expr_eq(e) == 1)
		printf("Warning:File(%s):Line(%d):'If'ξＰ('=')ȤäƤޤ.\n",e->filename,e->line);
	if(expr_and(e) == 1)
		printf("Warning:File(%s):Line(%d):'If'ξＰǥӥåѼ('&')ȤäƤޤ.\n",e->filename,e->line);
	if(expr_or(e) == 1)
		printf("Warning:File(%s):Line(%d):'If'ξＰǥӥå¼('|')ȤäƤޤ.\n",e->filename,e->line);

	if(e->next != NULL)
		expr_chky(e->next);
}

int	expr_eq(EXPR *a)
{
	EXPR	*e;

	e = a;

	if(e->opcode == op_ASSIGN)
		return(1);
	else if(e->opcode >= op_ADR && e->opcode <= op_MINUS){
		if(e->u.expr.left != NULL)
			expr_eq(e->u.expr.left);
		if(e->u.expr.right != NULL)
			expr_eq(e->u.expr.right);
		if(e->u.expr.third != NULL)
			expr_eq(e->u.expr.third);
	}
	else	return(0);
}

int	expr_and(EXPR *a)
{
	EXPR	*e;

	e = a;

	if(e->opcode == op_AND)
		return(1);
	else if(e->opcode >= op_ADR && e->opcode <= op_MINUS){
		if(e->u.expr.left != NULL)
			expr_and(e->u.expr.left);
		if(e->u.expr.right != NULL)
			expr_and(e->u.expr.right);
		if(e->u.expr.third != NULL)
			expr_and(e->u.expr.third);
	}
	else	return(0);
}

int	expr_or(EXPR *a)
{
	EXPR	*e;

	e = a;

	if(e->opcode == op_OR)
		return(1);
	else if(e->opcode >= op_ADR && e->opcode <= op_MINUS){
		if(e->u.expr.left != NULL)
			expr_or(e->u.expr.left);
		if(e->u.expr.right != NULL)
			expr_or(e->u.expr.right);
		if(e->u.expr.third != NULL)
			expr_or(e->u.expr.third);
	}
	else	return(0);
}
